DEFINT A-Z
DECLARE SUB ziDragging ()
' Return if mouse active and still dragging, or else exhausted

DECLARE SUB ziDrawBank (FromButton, ToButton)
' Draw a bank of buttons (using Bank array)

DECLARE SUB ziExhaust ()
' Return when no keystrokes and no mouse buttons

DECLARE SUB ziLoadFont (Font$)
' Load a specified font

DECLARE SUB ziLocateMCursor (XCoord, YCoord)
' Locate mouse cursor to a named point

DECLARE SUB ziMouseOnButton (FromButton, ToButton)
' Sets FoundButton

DECLARE SUB ziPublish (PrintString$, Size, Italic)
' Print a string
'   Size   = magnitude (per 8 pixels)
'   Italic = +1 to make italic
'          = +2 to make overprint (no background)

DECLARE SUB ziRadio (Button, FromButton, ToButton)
' Set one button in a Bank, resetting the rest

DECLARE SUB ziReadField (Min, Max, Permitted$)
' Read a field at the current TCursor location
'   Permitted$ contains:
'     * - any characters
'     . - allow one full-stop (as decimal)
'     A - auto-enter (when filled)
'     C - capitalise letters
'     E - ESC allowed to finish (skip) field
'     J - justify (especially for numeric)
'     N - numerics
'     P - password-type display
'     S - space
'     X - alphabetic
'     Y - Y or N (upper or lower)

DECLARE SUB ziSetMCursorVis (Status)
' Set visibility of mouse cursor
'   Status = 0 for OFF
'            1 for ON
'            2 for ENQUIRE (set MCursorVis)
'           10 for TEMPORARILY OFF
'           11 for RESTORED (set MCursorVis)

DECLARE SUB ziWander (Timeout!)
' Timeout  = in seconds (0 = none)
' Response =   0 = (0:00) timed out
'              n = (0:n)  displacement into Allowed$

' key           &h01xx  &h02xx  &h04xx  &h08xx  &h10xx  &h20xx  &h40xx
'                plain   CTRL    shift   Mouse    Fn   CTRL-Fn  shift-Fn

' Enter      0    *       *       -      double    -      -       -
' (left)     1    *       *       -      left     F1     ^F1     +F1
' (right)    2    *       *       -      right    F2     ^F2     +F2
' (up)       3    *       -       -      both     F3     ^F3     +F3
' (down)     4    *       -       -    leftdrag   F4     ^F4     +F4
                       
' Backspace  5    *       *       -    rightdrag  F5     ^F5     +F5
' Home       6    *       *       -    bothdrag   F6     ^F6     +F6
' End        7    *       *       -       -       F7     ^F7     +F7
                       
' PgUP       8    *       *       -       -       F8     ^F8     +F8
' PgDN       9    *       *       -       -       F9     ^F9     +F9

' Tab       10    *       -       *       -       F10    ^F10    +F10
' Escape    11    *       -       -       -       F11    ^F11    +F11
'           12    -       -       -       -       F12    ^F12    +F12

' Allowed$  = other allowed strokes
' (Note:  DClick is a flag permitting Double-clicks of mouse - slower!)

DEFINT A-Z
DECLARE SUB zsAlignGCursor ()
' Align graphic cursor to same as text cursor
'  - sets Row, Col, GXloc, GYloc

DECLARE SUB zsAlignTCursor ()
' Align text cursor to same as graphic cursor
'  - sets Row, Col, GXloc, GYloc
                    
DECLARE SUB zsLocateGCursor (XCoord, YCoord)
' Locate graphic cursor to a named point

DECLARE SUB zsPastel (XCoord, YCoord, Wide, Deep, colour1, colour2)
' Colour the defined oblong with a pastel mix of two colours
'  Deep = 0 or 1 - square
'       = n      - Y-pixel depth

DECLARE SUB zsSetScrnMode (Mode, HiRows, HiCols)
' Mode = 9 or 12
' HiRows = 1 to make high number of rows
' HiCols = 1 to make high number of cols (80)
' Set SCREEN parameters and blank the screen
'  - sets ScrnMode, Xmax, Ymax, Rows, Cols, XYRatio!
'  - uses FG and optionally BG (colours)

DECLARE SUB zsSubstitute (XCoord, YCoord, Wide, Deep, colour1, colour2)
' Substitute one colour with another within the defined oblong
'  Deep = 0 or 1 - square
'       = n      - Y-pixel depth

DECLARE SUB zzBasicInt (IntType)
' Execute interrupt (params in REGS.AX etc)

DECLARE SUB zzInPath (Field$)
' Return full path to a file (in same string)

'================================================
'/  UK copyright (c) 1995 by Future Publishing
'/
'/
'/
'/
'================================================
TYPE REGISTERS
  AX AS INTEGER
  BX AS INTEGER
  CX AS INTEGER
  DX AS INTEGER
  DS AS INTEGER
  SI AS INTEGER
  ES AS INTEGER
  DI AS INTEGER
  FL AS INTEGER
END TYPE

TYPE Buttons
  Xloc AS INTEGER
  Yloc AS INTEGER
  Wide AS INTEGER
  Deep AS INTEGER
'  0 = checkbutton
'  1 = square sculptured
'  n = Y-pixels deep
  State AS INTEGER
'  0 = off
'  1 = on
  Active AS INTEGER
'  0 = inactive
'  1 = active
END TYPE

CONST Pi! = 3.14159
CONST Ex! = 2.71828
CONST DegToRad! = .0174533
CONST RadToDeg! = 57.2958

CONST ziNoShift = &H1
CONST ziCTRL = &H2
CONST ziShift = &H4
CONST ziMouse = &H8
CONST ziFn = &H10
CONST ziCTRLFn = &H20
CONST ziShiftFn = &H40

CONST ziL = 1
CONST ziR = 2
CONST ziUp = 3
CONST ziDn = 4
CONST ziBS = 5
CONST ziHome = 6
CONST ziEnd = 7
CONST ziPgUp = 8
CONST ziPgDn = 9
CONST ziTab = 10
CONST ziEsc = 11

CONST ziDbl = 0
CONST ziBoth = 3
CONST ziLDrag = 4
CONST ziRDrag = 5
CONST ziBothDrag = 6

DIM SHARED REGS AS REGISTERS
DIM SHARED Bank(20) AS Buttons
DIM SHARED Bad, Module$
DIM SHARED Mouse, MCursorVis, MXloc, MYloc
DIM SHARED DClick
DIM SHARED ScrnMode, BG, FG, TCursor
DIM SHARED Xmax, Ymax, GXloc, GYloc, XYratio!
DIM SHARED Rows, Cols, Row, Col
DIM SHARED Allowed$, Field$
DIM SHARED FoundButton
DIM SHARED Font(255, 7)
DIM SHARED Response, HResponse, LResponse

'++++++++++++++++++++++++
RANDOMIZE TIMER
ON ERROR GOTO RESUMENEXT
RESUMENEXT:
  IF ERR = 255 THEN
    CLS
    BEEP
    PRINT "Cannot find module "; Module$
    SLEEP
    SYSTEM
  END IF
  IF ERR THEN
    Bad = ERR
    RESUME NEXT
  END IF
'++++++++++++++++++++++++
' Test for presence of a mouse
Mouse = 0
REGS.AX = 0
CALL zzBasicInt(&H33)
IF REGS.AX THEN
  Mouse = 1
  CALL ziSetMCursorVis(0)
END IF
'++++++++++++++++++++++++
' Load the ASCII font
CALL ziLoadFont("Ascii8x8")
'/==================================/'
'/  End of Standard Piecrust code   /'
'/==================================/'


'+++++++++++++++++++++++++++++++++++++

BG = 0: FG = 8
CALL zsSetScrnMode(9, 1, 1)
BG = 7


DIM ziRoutine$(20)

DATA "ziDragging"
DATA "ziDrawBank"
DATA "ziExhaust"
DATA "ziLoadFont"
DATA "ziLocateMCursor"
DATA "ziMouseOnButton"
DATA "ziPublish"
DATA "ziRadio"
DATA "ziReadField"
DATA "ziSetMCursorVis"
DATA "ziWander"
DATA "*"

i = 0
DO
  i = i + 1
  READ ziRoutine$(i)
LOOP UNTIL ziRoutine$(i) = "*"


DIM zsRoutine$(20)

DATA "zsAlignGCursor"
DATA "zsAlignTCursor"
DATA "zsLocateGCursor"
DATA "zsPastel"
DATA "zsSetScrnMode"
DATA "zsSubstitute"
DATA "*"

i = 0
DO
  i = i + 1
  READ zsRoutine$(i)
LOOP UNTIL zsRoutine$(i) = "*"

DIM zzRoutine$(20)

DATA "zzBasicInt"
DATA "zzInPath"
DATA "*"

i = 0
DO
  i = i + 1
  READ zzRoutine$(i)
LOOP UNTIL zzRoutine$(i) = "*"

CALL ziSetMCursorVis(1)

Choice = 1
OldChoice = 0
            
DO
  CALL ziSetMCursorVis(10)
  LINE (0, 0)-(Xmax, Ymax), BG, BF
  CALL ziSetMCursorVis(11)

  FOR a = 1 TO 20
    Bank(a).State = 0
    Bank(a).Active = 0
  NEXT

  FOR a = 1 TO 4

    Bank(a).Xloc = Xmax / 5 * a - 10
    Bank(a).Yloc = 100
    Bank(a).Wide = 20
    Bank(a).Deep = 0
    Bank(a).Active = 1

  NEXT

  Bank(5).Xloc = Xmax / 2 - 40
  Bank(5).Yloc = 50
  Bank(5).Wide = 80
  Bank(5).Deep = 13
  Bank(5).Active = 1

  CALL zsLocateGCursor(Bank(5).Xloc + 16, 53)
  CALL ziPublish("Select", 0, 2)

  FG = 4
  LeftMargin = Bank(1).Xloc - 20
  CALL zsLocateGCursor(LeftMargin, 90)
  CALL ziPublish("zi Routines", 0, 3)

  rowused = 120
  i = 0
  DO
    i = i + 1
    rowused = rowused + 10
    IF ziRoutine$(i) = "*" THEN EXIT DO
    CALL zsLocateGCursor(Bank(1).Xloc - 20, rowused)
    CALL ziPublish(ziRoutine$(i), 0, 2)
  LOOP

  FG = 0
  LeftMargin = Bank(2).Xloc - 20
  CALL zsLocateGCursor(LeftMargin, 90)
  CALL ziPublish("zs Routines", 0, 3)

  rowused = 120
  i = 0
  DO
    i = i + 1
    rowused = rowused + 10
    IF zsRoutine$(i) = "*" THEN EXIT DO
    CALL zsLocateGCursor(Bank(2).Xloc - 20, rowused)
    CALL ziPublish(zsRoutine$(i), 0, 2)
  LOOP

  FG = 1
  LeftMargin = Bank(3).Xloc - 20
  CALL zsLocateGCursor(LeftMargin, 90)
  CALL ziPublish("zz Routines", 0, 3)

  rowused = 120
  i = 0
  DO
    i = i + 1
    rowused = rowused + 10
    IF zzRoutine$(i) = "*" THEN EXIT DO
    CALL zsLocateGCursor(Bank(3).Xloc - 20, rowused)
    CALL ziPublish(zzRoutine$(i), 0, 2)
  LOOP
 

  FG = 8
  CALL zsLocateGCursor(Bank(4).Xloc - 20, 90)
  CALL ziPublish("End Demo", 0, 2)

  Allowed$ = " "
  CALL ziExhaust

  DO
    IF Choice = OldChoice THEN
      OldChoice = 0
      GOSUB Process
      EXIT DO
    ELSE
      OldChoice = Choice
    END IF
   
    IF Choice < 1 THEN Choice = 4
    IF Choice > 4 THEN Choice = 1
    CALL ziRadio(Choice, 1, 4)
    CALL ziDrawBank(1, 5)
    CALL ziWander(0)
    CALL ziExhaust
    SELECT CASE HResponse
    CASE 0
      SELECT CASE LResponse
      CASE 1
        Choice = Choice + 1
      END SELECT
    CASE ziNoShift
      SELECT CASE LResponse
      CASE ziEnter
        GOSUB Process
        EXIT DO
      CASE ziTab
        Choice = Choice + 1
      CASE ziL
        Choice = Choice - 1
      CASE ziR
        Choice = Choice + 1
      END SELECT
    CASE ziShift
      SELECT CASE LResponse
      CASE ziTab
        Choice = Choice - 1
      END SELECT
    CASE ziMouse
      SELECT CASE LResponse
      CASE ziL
        CALL ziMouseOnButton(1, 5)
        SELECT CASE FoundButton
        CASE 0
          OldChoice = 0
        CASE 1 TO 4
          Choice = FoundButton
        CASE 5
          OldChoice = 0
          GOSUB Process
          EXIT DO
        END SELECT
      END SELECT
    END SELECT
  LOOP

LOOP


Process:
  DO
    CALL ziSetMCursorVis(10)
    LINE (0, 0)-(Xmax, Ymax), BG, BF
    CALL ziSetMCursorVis(11)
    CALL zsLocateGCursor(Xmax / 2 - 80, 5)
    SELECT CASE Choice
    CASE 1
      FG = 4
      CALL ziPublish("zi Routines", 2, 2)
      i = 0
      rowused = 100
      DO
        i = i + 1
        rowused = rowused + 20
        CALL zsLocateGCursor(Xmax / 2 - 80, rowused)
        IF ziRoutine$(i) = "*" THEN EXIT DO
        CALL ziPublish(ziRoutine$(i), 1, 3)
      LOOP

    CASE 2
      FG = 0
      CALL ziPublish("zs Routines", 2, 2)
      i = 0
      rowused = 100
      DO
        i = i + 1
        rowused = rowused + 20
        CALL zsLocateGCursor(Xmax / 2 - 80, rowused)
        IF zsRoutine$(i) = "*" THEN EXIT DO
        CALL ziPublish(zsRoutine$(i), 1, 3)
      LOOP

    CASE 3
      FG = 1
      CALL ziPublish("zz Routines", 2, 2)
      i = 0
      rowused = 100
      DO
        i = i + 1
        rowused = rowused + 20
        CALL zsLocateGCursor(Xmax / 2 - 80, rowused)
        IF zzRoutine$(i) = "*" THEN EXIT DO
        CALL ziPublish(zzRoutine$(i), 1, 3)
      LOOP
 
    CASE 4
      LINE (0, 0)-(Xmax, Ymax), 7, BF
      LOCATE Rows / 2 - 3, Cols / 2 - 12
      CALL zsAlignGCursor
      FG = 5
      CALL ziPublish("Goodbye!", 3, 3)
      CALL ziWander(5)
      SYSTEM
    END SELECT

    Command = i

    CALL zsLocateGCursor(Xmax / 2 - 80, 100)
    CALL ziPublish("Return to Menu", 1, 2)

    FOR a = 1 TO 20
      Bank(a).Active = 0
    NEXT

    FOR i = 1 TO Command
    
      Bank(i).Xloc = Xmax / 2 - 100
      Bank(i).Yloc = 80 + 20 * i
      Bank(i).Wide = 10
      Bank(i).Deep = 1
      Bank(i).State = 0
      Bank(i).Active = 1
     
    NEXT
 
    Bank(1).State = 1
    CurrCommand = 1
    OldCommand = 0
    DO
      IF OldCommand = CurrCommand THEN EXIT DO
      OldCommand = CurrCommand
      IF CurrCommand < 1 THEN CurrCommand = Command
      IF CurrCommand > Command THEN CurrCommand = 1
      CALL ziRadio(CurrCommand, 1, Command)
      CALL ziDrawBank(1, Command)
      CALL ziWander(0)
      CALL ziExhaust
      SELECT CASE HResponse
      CASE 0
        CurrCommand = CurrCommand + 1
        CASE ziNoShift
          SELECT CASE LResponse
          CASE ziEnter
            EXIT DO
          CASE ziUp
            CurrCommand = CurrCommand - 1
          CASE ziDn
            CurrCommand = CurrCommand + 1
        END SELECT
      CASE ziMouse
        IF LResponse = 1 THEN
          CALL ziMouseOnButton(1, Command)
          IF FoundButton THEN
            CurrCommand = FoundButton
          ELSE
            OldCommand = 0
          END IF
        END IF
      END SELECT
    LOOP
   
    CurrCommand = CurrCommand - 1
    IF CurrCommand = 0 THEN RETURN
   
    CALL ziSetMCursorVis(10)
    LINE (0, 0)-(Xmax, Ymax), 7, BF
    CALL ziSetMCursorVis(11)
    CALL zsLocateGCursor(2, 2)
    LOCATE 4, 10

    SELECT CASE Choice
    CASE 1
      CALL ziPublish(ziRoutine$(CurrCommand), 2, 1)
      CALL zsAlignGCursor
      SELECT CASE CurrCommand
      CASE 1: GOSUB zziDragging
      CASE 2: GOSUB zziDrawBank
      CASE 3: GOSUB zziExhaust
      CASE 4: GOSUB zziLoadFont
      CASE 5: GOSUB zziLocateMCursor
      CASE 6: GOSUB zziMouseOnButton
      CASE 7: GOSUB zziPublish
      CASE 8: GOSUB zziRadio
      CASE 9: GOSUB zziReadField
      CASE 10: GOSUB zziSetMCursorVis
      CASE 11: GOSUB zziWander
      END SELECT
    CASE 2
      CALL ziPublish(zsRoutine$(CurrCommand), 2, 1)
      CALL zsAlignGCursor
      SELECT CASE CurrCommand
      CASE 1: GOSUB zzsAlignGCursor
      CASE 2: GOSUB zzsAlignTCursor
      CASE 3: GOSUB zzsLocateGCursor
      CASE 4: GOSUB zzsPastel
      CASE 5: GOSUB zzsSetScrnMode
      CASE 6: GOSUB zzsSubstitute
      END SELECT
    CASE 3
      CALL ziPublish(zzRoutine$(CurrCommand), 2, 1)
      CALL zsAlignGCursor
      SELECT CASE CurrCommand
      CASE 1: GOSUB zzzBasicInt
      CASE 2: GOSUB zzzInPath
      END SELECT
    END SELECT

    CALL ziWander(0)
    CALL ziExhaust
  LOOP

  RETURN

zziDragging:
zziExhaust:
  CALL ziPublish("ziDragging ", 0, 3)
  CALL ziPublish("and ", 0, 2)
  CALL ziPublish("ziExhaust ", 0, 3)
  CALL ziPublish("are two of the most usual subroutines", 0, 2)
  GOSUB NextLine
  CALL ziPublish("used to follow the ", 0, 2)
  CALL ziPublish("ziWander ", 0, 3)
  CALL ziPublish("subroutine, which waits for a", 0, 2)
  GOSUB NextLine
  CALL ziPublish("keystroke or a mouse click.", 0, 2)
  PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("ziDragging ", 0, 3)
  CALL ziPublish("returns immediately if the value in Response", 0, 2)
  GOSUB NextLine
  CALL ziPublish("indicates that a dragging operation was detected", 0, 2)
  GOSUB NextLine
  CALL ziPublish("and is still in progress.  If no dragging was done", 0, 2)
  GOSUB NextLine
  CALL ziPublish("or if it has stopped, the subroutine ", 0, 2)
  CALL ziPublish("ziExhaust ", 0, 3)
  CALL ziPublish("is called", 0, 2)
  GOSUB NextLine
  CALL ziPublish("automatically. Note that you can use it repeatedly", 0, 2)
  GOSUB NextLine
  CALL ziPublish("while Response still has a value, instead of", 0, 2)
  GOSUB NextLine
  CALL ziPublish("re-CALLing ziWander.", 0, 2)
  PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("ziExhaust ", 0, 3)
  CALL ziPublish("returns only when there has been no keystroke", 0, 2)
  GOSUB NextLine
  CALL ziPublish("or mouse action; this is useful for clearing", 0, 2)
  GOSUB NextLine
  CALL ziPublish("the queue, preventing unwanted extra keystrokes", 0, 2)
  GOSUB NextLine
  CALL ziPublish("being interpreted incorrectly.", 0, 2)
  GOSUB NextLine
  CALL ziPublish("Note that the shared variable ", 0, 2)
  CALL ziPublish("Response ", 0, 3)
  CALL ziPublish("is reset to zero", 0, 2)
  GOSUB NextLine
  CALL ziPublish("but ", 0, 2)
  CALL ziPublish("HResponse ", 0, 3)
  CALL ziPublish("and ", 0, 2)
  CALL ziPublish("LResponse ", 0, 3)
  CALL ziPublish("are left undisturbed.", 0, 2)
  PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("        CALL ziWander(5)", 0, 2)
  GOSUB NextLine
  CALL ziPublish("        DO", 0, 2)
  GOSUB NextLine
  CALL ziPublish("          CALL ziDragging", 0, 2)
  GOSUB NextLine
  CALL ziPublish("          IF Response THEN GOSUB StillDragging", 0, 2)
  GOSUB NextLine
  CALL ziPublish("        LOOP UNTIL Response = 0", 0, 2)
  RETURN
zziDrawBank:
  CALL ziPublish("ziDrawBank ", 0, 3)
  CALL ziPublish("provides the ability to draw a bank of buttons", 0, 2)
  GOSUB NextLine
  CALL ziPublish("(switches and checkboxes) - up to twenty at a time.", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("Each button is defined in a shared array called ", 0, 2)
  CALL ziPublish("Bank", 0, 3)
  CALL ziPublish(".", 0, 2)
  GOSUB NextLine
  CALL ziPublish("The associated fields within each button definition are:", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("Bank(n).Xloc   - ", 0, 3)
  CALL ziPublish("the X coordinate of the top left corner", 0, 2)
  GOSUB NextLine
  CALL ziPublish("Bank(n).Yloc   - ", 0, 3)
  CALL ziPublish("the Y coordinate of the top left corner", 0, 2)
  GOSUB NextLine
  CALL ziPublish("Bank(n).Wide   - ", 0, 3)
  CALL ziPublish("the width of the button in X-pixels", 0, 2)
  GOSUB NextLine
  CALL ziPublish("Bank(n).Deep   - ", 0, 3)
  CALL ziPublish("the depth of the button in Y-pixels", 0, 2)
  GOSUB NextLine
  CALL ziPublish("                 ", 0, 3)
  CALL ziPublish("Note: 0 = checkbox type", 0, 2)
  GOSUB NextLine
  CALL ziPublish("                 ", 0, 3)
  CALL ziPublish("      1 = square button: depth calculated", 0, 2)
  GOSUB NextLine
  CALL ziPublish("Bank(n).State  - ", 0, 3)
  CALL ziPublish("0 is OFF;       1 is ON", 0, 2)
  GOSUB NextLine
  CALL ziPublish("Bank(n).Active - ", 0, 3)
  CALL ziPublish("0 is INACTIVE;  1 is ACTIVE", 0, 2)
  PRINT : PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("    CALL ziDrawBank(", 0, 2)
  FG = 8: CALL ziPublish("from_button", 0, 2)
  FG = 4: CALL ziPublish(", ", 0, 2)
  FG = 8: CALL ziPublish("to_button", 0, 2)
  FG = 4: CALL ziPublish(")", 0, 2)
  PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("..where ", 0, 2)
  GOSUB NextLine
  FG = 8: CALL ziPublish("        from_button ", 0, 2)
  FG = 4: CALL ziPublish("is the first button to draw", 0, 2)
  GOSUB NextLine
  FG = 8: CALL ziPublish("        to_button ", 0, 2)
  FG = 4: CALL ziPublish("is the last button to draw", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("Please note the following:", 0, 2)
  GOSUB NextLine
  CALL ziPublish("  1. Only ACTIVE buttons will be drawn", 0, 2)
  GOSUB NextLine
  CALL ziPublish("  2. Checkboxes will be printed GREY on WHITE", 0, 2)
  LOCATE CSRLIN + 2, 1
  CALL zsAlignGCursor
  remline = GYloc
  a = (Xmax - 79) \ 5
  FOR i = 1 TO 4
    Bank(i).Xloc = (a + 20) * i - 20
    Bank(i).Yloc = remline
    Bank(i).Wide = 20
    IF i < 3 THEN
      Bank(i).Deep = 0
    ELSE
      Bank(i).Deep = 1
    END IF
    Bank(i).State = i MOD 2
    Bank(i).Active = 1
  NEXT
  CALL ziDrawBank(1, 4)
  CALL zsLocateGCursor(0, remline)
  PRINT : PRINT : GOSUB NextLine
  CALL zsLocateGCursor(a - 38, GYloc)
  CALL ziPublish("checkbox ON", 0, 3)
  CALL zsLocateGCursor(a + a - 18, GYloc)
  CALL ziPublish("checkbox OFF", 0, 3)
  CALL zsLocateGCursor(3 * a + 10, GYloc)
  CALL ziPublish("button ON", 0, 3)
  CALL zsLocateGCursor(4 * a + 30, GYloc)
  CALL ziPublish("button OFF", 0, 3)
  RETURN
zziLocateMCursor:
  CALL ziPublish("ziLocateMCursor ", 0, 3)
  CALL ziPublish("puts the hotspot of the mouse cursor at a", 0, 2)
  GOSUB NextLine
  CALL ziPublish("particular pixel, as prescribed by X and Y", 0, 2)
  GOSUB NextLine
  CALL ziPublish("coordinates; these are then recorded in the shared", 0, 2)
  GOSUB NextLine
  CALL ziPublish("variables MXloc and MYloc.", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("This subroutine also makes the mouse cursor visible if", 0, 2)
  GOSUB NextLine
  CALL ziPublish("it is not visible, and records this by setting the shared", 0, 2)
  GOSUB NextLine
  CALL ziPublish("variable MCursorVis to 1 (=visible).", 0, 2)
  PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("   CALL ziLocateMCursor(", 0, 2)
  FG = 8: CALL ziPublish("X_coordinate", 0, 2)
  FG = 4: CALL ziPublish(", ", 0, 2)
  FG = 8: CALL ziPublish("Y_coordinate", 0, 2)
  FG = 4: CALL ziPublish(")", 0, 2)
  RETURN
zziMouseOnButton:
  CALL ziPublish("ziMouseOnButton ", 0, 3)
  CALL ziPublish("identifies whether MXloc and MYloc (the coordinates", 0, 2)
  GOSUB NextLine
  CALL ziPublish("of the mouse cursor) are within the boundaries of any active", 0, 2)
  GOSUB NextLine
  CALL ziPublish("button defined (within a range) in the shared Bank array.", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("If the mouse cursor is within a button, the shared variable", 0, 2)
  GOSUB NextLine
  CALL ziPublish("FoundButton ", 0, 3)
  CALL ziPublish("will contain the number of that button. If the mouse", 0, 2)
  GOSUB NextLine
  CALL ziPublish("cursor is NOT within any active button, ", 0, 2)
  CALL ziPublish("FoundButton ", 0, 3)
  GOSUB NextLine
  CALL ziPublish("will contain 0.", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("This subroutine will usually follow a CALL to ziWander,", 0, 2)
  GOSUB NextLine
  CALL ziPublish("after it has been found that a mouse button has been", 0, 2)
  GOSUB NextLine
  CALL ziPublish("pressed. Often the next command will be a CALL to", 0, 2)
  GOSUB NextLine
  CALL ziPublish("ziRadio, or perhaps the sequence..", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("    Bank(FoundButton).State = Bank(FoundButton).State XOR 1", 0, 2)
  GOSUB NextLine
  CALL ziPublish("    CALL ziDrawBank(FoundButton,FoundButton)", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("..which changes the state (ON or OFF) of the particular", 0, 2)
  GOSUB NextLine
  CALL ziPublish("button.", 0, 2)
  PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("The syntax is..", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("    CALL ziMouseOnButton(", 0, 2)
  FG = 8: CALL ziPublish("from_button", 0, 2)
  FG = 4: CALL ziPublish(", ", 0, 2)
  FG = 8: CALL ziPublish("to_button", 0, 2)
  FG = 4: CALL ziPublish(")", 0, 2)
  PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("..where ", 0, 2)
  GOSUB NextLine
  FG = 8: CALL ziPublish("        from_button ", 0, 2)
  FG = 4: CALL ziPublish("is the first button to test", 0, 2)
  GOSUB NextLine
  FG = 8: CALL ziPublish("        to_button ", 0, 2)
  FG = 4: CALL ziPublish("is the last button to test", 0, 2)
  RETURN
zziLoadFont:
zziPublish:
  CALL ziPublish("ziLoadFont ", 0, 3)
  CALL ziPublish("and ", 0, 2)
  CALL ziPublish("ziPublish ", 0, 3)
  CALL ziPublish("are related: the former (which", 0, 2)
  GOSUB NextLine
  CALL ziPublish("should be called only once) brings a prefabricated OVL", 0, 2)
  GOSUB NextLine
  CALL ziPublish("into memory and moves values into the shared array FONT.", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("FONT carries bit-images (8x8) of 256 characters, and is", 0, 2)
  GOSUB NextLine
  CALL ziPublish("used by ziPublish in order to generate characters on the", 0, 2)
  GOSUB NextLine
  CALL ziPublish("screen.", 0, 2)
  PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("        CALL ziLoadFont(", 0, 2)
  FG = 8: CALL ziPublish("Fontname$", 0, 2)
  FG = 4: CALL ziPublish(")", 0, 2)
  PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("..where ", 0, 2)
  CALL ziPublish("Fontname$ ", 0, 3)
  CALL ziPublish("is a variable or constant with the major", 0, 2)
  GOSUB NextLine
  CALL ziPublish("name of the OVL.  The font file may be anywhere in the PATH.", 0, 2)
  PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("zzPublish enables you to print a string at the current", 0, 2)
  GOSUB NextLine
  CALL ziPublish("graphic cursor in a variety of sizes and styles. The ", 0, 2)
  GOSUB NextLine
  CALL ziPublish("current colours indicated in FG and BG will be used.", 0, 2)
  PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("        CALL ziPublish(", 0, 2)
  FG = 8: CALL ziPublish("String$, fontsize, style", 0, 2)
  FG = 4: CALL ziPublish(")", 0, 2)
  PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("..where ", 0, 2)
  CALL ziPublish("String$ ", 0, 3)
  CALL ziPublish("is a variable or constant to be printed", 0, 2)
  GOSUB NextLine
  CALL ziPublish("on the screen; ", 0, 2)
  CALL ziPublish("fontsize ", 0, 3)
  CALL ziPublish("is the size of characters (0 or 1", 0, 2)
  GOSUB NextLine
  CALL ziPublish("is normal); and ", 0, 2)
  CALL ziPublish("style ", 0, 3)
  CALL ziPublish("indicates how the string will appear:", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("     0 = normal using FG and BG", 0, 2)
  GOSUB NextLine
  CALL ziPublish("     1 = ", 0, 2)
  CALL ziPublish("italic ", 0, 3)
  CALL ziPublish("using FG and BG", 0, 2)
  GOSUB NextLine
  CALL ziPublish("     2 = normal using FG only", 0, 2)
  GOSUB NextLine
  CALL ziPublish("     3 = ", 0, 2)
  CALL ziPublish("italic ", 0, 3)
  CALL ziPublish("using FG only", 0, 2)
  PRINT
  GOSUB NextLine
  CALL ziPublish("The graphics cursor is realigned to the next unused", 0, 2)
  GOSUB NextLine
  CALL ziPublish("screen position - like the semicolon option on PRINT.", 0, 2)
  RETURN
zziRadio:
  CALL ziPublish("zziRadio ", 0, 3)
  CALL ziPublish("enables you to control a bank of radio-type switches,", 0, 2)
  GOSUB NextLine
  CALL ziPublish("wherein only ONE switch or button is allowed in the ON state", 0, 2)
  GOSUB NextLine
  CALL ziPublish("at any particular moment.  It turns ON a specified button", 0, 2)
  GOSUB NextLine
  CALL ziPublish("and turns OFF any other in the range. The buttons are updated", 0, 2)
  GOSUB NextLine
  CALL ziPublish("on the screen (through calling ziDrawBank).", 0, 2)
  PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("     CALL zziRADIO(", 0, 2)
  FG = 8: CALL ziPublish("button", 0, 2)
  FG = 4: CALL ziPublish(", ", 0, 2)
  FG = 8: CALL ziPublish("from_button", 0, 2)
  FG = 4: CALL ziPublish(", ", 0, 2)
  FG = 8: CALL ziPublish("to_button", 0, 2)
  FG = 4: CALL ziPublish(")", 0, 2)
  PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("..where", 0, 2)
  GOSUB NextLine
  FG = 8: CALL ziPublish("    - button ", 0, 2)
  FG = 4: CALL ziPublish("is the number of the button to be ON", 0, 2)
  GOSUB NextLine
  FG = 8: CALL ziPublish("    - from_button ", 0, 22)
  FG = 4: CALL ziPublish("is the lowest numbered button (in Bank) in range", 0, 2)
  GOSUB NextLine
  FG = 8: CALL ziPublish("    - to_button ", 0, 2)
  FG = 4: CALL ziPublish("is the highest numbered button in range", 0, 2)
  RETURN
zziReadField:
  CALL ziPublish("ziReadField ", 0, 3)
  CALL ziPublish("controls input from a keyboard, creating a string", 0, 2)
  GOSUB NextLine
  CALL ziPublish("in the shared variable ", 0, 2)
  CALL ziPublish("Field$", 0, 3)
  CALL ziPublish(".", 0, 2)
  GOSUB NextLine
  CALL ziPublish("You can control the minimum and maximum number of strokes", 0, 2)
  GOSUB NextLine
  CALL ziPublish("and the type of key values permitted.", 0, 2)
  PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("    CALL ziReadField(", 0, 2)
  FG = 8: CALL ziPublish("minimum", 0, 2)
  FG = 4: CALL ziPublish(", ", 0, 2)
  FG = 8: CALL ziPublish("maximum", 0, 2)
  FG = 4: CALL ziPublish(", ", 0, 2)
  FG = 8: CALL ziPublish("permitted$", 0, 2)
  FG = 4: CALL ziPublish(")", 0, 2)
  PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("..where", 0, 2)
  GOSUB NextLine
  FG = 8: CALL ziPublish("  - minimum ", 0, 2)
  FG = 4: CALL ziPublish("is an integer variable or constant minimum strokes", 0, 2)
  GOSUB NextLine
  FG = 8: CALL ziPublish("  - maximum ", 0, 2)
  FG = 4: CALL ziPublish("is an integer variable or constant maximum strokes", 0, 2)
  GOSUB NextLine
  FG = 8: CALL ziPublish("  - permitted$ ", 0, 2)
  FG = 4: CALL ziPublish("contains characters defining the input style and", 0, 2)
  GOSUB NextLine
  CALL ziPublish("    restrictions.", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("Characters governing keystroke entry:", 0, 2)
  PRINT : GOSUB NextLine
  FG = 8: CALL ziPublish("    * ", 0, 2)
  FG = 4: CALL ziPublish("anything allowed ", 0, 2)
  FG = 8: CALL ziPublish("    N ", 0, 2)
  FG = 4: CALL ziPublish("justify (numeric)", 0, 2)
  GOSUB NextLine
  FG = 8: CALL ziPublish("    . ", 0, 2)
  FG = 4: CALL ziPublish("decimal allowed  ", 0, 2)
  FG = 8: CALL ziPublish("    P ", 0, 2)
  FG = 4: CALL ziPublish("password style", 0, 2)
  GOSUB NextLine
  FG = 8: CALL ziPublish("    A ", 0, 2)
  FG = 4: CALL ziPublish("auto-enter       ", 0, 2)
  FG = 8: CALL ziPublish("    S ", 0, 2)
  FG = 4: CALL ziPublish("space allowed", 0, 2)
  GOSUB NextLine
  FG = 8: CALL ziPublish("    C ", 0, 2)
  FG = 4: CALL ziPublish("capitalise       ", 0, 2)
  FG = 8: CALL ziPublish("    X ", 0, 2)
  FG = 4: CALL ziPublish("alphabet allowed", 0, 2)
  GOSUB NextLine
  FG = 8: CALL ziPublish("    E ", 0, 2)
  FG = 4: CALL ziPublish("ESC skips field  ", 0, 2)
  FG = 8: CALL ziPublish("    Y ", 0, 2)
  FG = 4: CALL ziPublish("means Y or N allowed", 0, 2)
  GOSUB NextLine
  FG = 8: CALL ziPublish("    J ", 0, 2)
  FG = 4: CALL ziPublish("justify (numeric)", 0, 2)
  PRINT : PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("For example:", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("         ", 0, 2)
  FG = 8
  CALL ziPublish("CALL ziReadField(3,7," + CHR$(34) + "NJE." + CHR$(34) + ")", 0, 2)
  FG = 4
  PRINT : GOSUB NextLine
  CALL ziPublish("         ", 0, 2)
  CALL ziPublish("-controls the entry of a numeric value, optionally", 0, 2)
  GOSUB NextLine
  CALL ziPublish("         ", 0, 2)
  CALL ziPublish(" containing a decimal point, between 3 and 7 bytes", 0, 2)
  GOSUB NextLine
  CALL ziPublish("         ", 0, 2)
  CALL ziPublish(" long, justified to the right; zero length permitted", 0, 2)
  PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("Note: ", 0, 2)
  FG = 8: CALL ziPublish("P ", 0, 2): FG = 4
  CALL ziPublish("enables controlled entry of values WITHOUT display.", 0, 2)
  RETURN
zziSetMCursorVis:
  CALL ziPublish("ziSetMCursor ", 0, 3)
  CALL ziPublish("makes it easy to turn on and off the mouse cursor.", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("There is a single parameter:", 0, 2)
  GOSUB NextLine
  FG = 8: CALL ziPublish("         0 ", 0, 2)
  FG = 4: CALL ziPublish("- to turn the mouse cursor OFF", 0, 2)
  GOSUB NextLine
  FG = 8: CALL ziPublish("         1 ", 0, 2)
  FG = 4: CALL ziPublish("- to turn the mouse cursor ON", 0, 2)
  GOSUB NextLine
  FG = 8: CALL ziPublish("        10 ", 0, 2)
  FG = 4: CALL ziPublish("- to turn the mouse cursor OFF ", 0, 2)
  CALL ziPublish("temporarily", 0, 3)
  GOSUB NextLine
  FG = 8: CALL ziPublish("        11 ", 0, 2)
  FG = 4: CALL ziPublish("- to restore the mouse cursor after 10", 0, 2)
  PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("It should be noted that changing the screen while the", 0, 2)
  GOSUB NextLine
  CALL ziPublish("mouse cursor is present can create mistakes; you should", 0, 2)
  GOSUB NextLine
  CALL ziPublish("bracket any screen command with ", 0, 2)
  FG = 8: CALL ziPublish("CALL ziSetMCursor(10)", 0, 2): FG = 4
  GOSUB NextLine
  CALL ziPublish("and ", 0, 2)
  FG = 8: CALL ziPublish("CALL ziSetMCursor(11) ", 0, 2): FG = 4
  CALL ziPublish("to turn it off temporarily", 0, 2)
  PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("Note that all the ", 0, 2)
  CALL ziPublish("zi ", 0, 3)
  CALL ziPublish("and ", 0, 2)
  CALL ziPublish("zs ", 0, 3)
  CALL ziPublish("subroutines that change the screen do", 0, 2)
  GOSUB NextLine
  CALL ziPublish("this automatically.", 0, 2)
  RETURN
zziWander:
  CALL ziPublish("ziWander ", 0, 3)
  CALL ziPublish("handles both keyboard and mouse input, passing back", 0, 2)
  GOSUB NextLine
  CALL ziPublish("the results in the integer variable ", 0, 2)
  CALL ziPublish("Response", 0, 3)
  CALL ziPublish(".", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("When a keystroke or mouse click will be meaningful,", 0, 2)
  GOSUB NextLine
  CALL ziPublish("a CALL to this subroutine will monitor both keyboard", 0, 2)
  GOSUB NextLine
  CALL ziPublish("and mouse, and respond to the first available input.", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("If there is a mouse event, the mouse cursor's position", 0, 2)
  GOSUB NextLine
  CALL ziPublish("will be recorded in shared variables ", 0, 2)
  CALL ziPublish("MXloc ", 0, 3)
  CALL ziPublish("and ", 0, 2)
  CALL ziPublish("MYloc", 0, 3)
  CALL ziPublish(".", 0, 2)
  PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("   CALL ziWander(", 0, 2)
  FG = 8: CALL ziPublish("timeout", 0, 2): FG = 4
  CALL ziPublish(")", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("..where", 0, 2)
  GOSUB NextLine
  FG = 8: CALL ziPublish("       timeout ", 0, 2): FG = 4
  CALL ziPublish("is an integer variable or constant number of seconds.", 0, 2)
  GOSUB NextLine
  CALL ziPublish("       (if timeout = 0 then no timeout will occur)", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("Besides control keys, other allowed keys are held in the", 0, 2)
  GOSUB NextLine
  CALL ziPublish("shared string variable ", 0, 2)
  CALL ziPublish("Allowed$", 0, 3)
  CALL ziPublish(".", 0, 2)
  GOSUB NextLine
  CALL ziPublish("Response ", 0, 3)
  CALL ziPublish("is also recorded as ", 0, 2)
  CALL ziPublish("HResponse ", 0, 3)
  CALL ziPublish("(high order value)", 0, 2)
  GOSUB NextLine
  CALL ziPublish("and ", 0, 2)
  CALL ziPublish("LResponse ", 0, 3)
  CALL ziPublish("(low order value).", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("  HResponse indicates the source of the input:", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("     =  0               -timeout or Allowed$", 0, 2)
  GOSUB NextLine
  CALL ziPublish("     =  1 [ziNoShift]   -control keys", 0, 2)
  GOSUB NextLine
  CALL ziPublish("     =  2 [ziCTRL]      -CTRL shifted control keys", 0, 2)
  GOSUB NextLine
  CALL ziPublish("     =  4 [ziShift]     -shift used with control keys", 0, 2)
  GOSUB NextLine
  CALL ziPublish("     =  8 [ziMouse]     -mouse responded", 0, 2)
  GOSUB NextLine
  CALL ziPublish("     = 16 [ziFn]        -Function keys", 0, 2)
  GOSUB NextLine
  CALL ziPublish("     = 32 [ziCTRLFn]    -CTRL shifted Function keys", 0, 2)
  GOSUB NextLine
  CALL ziPublish("     = 64 [ziShiftFn]   -shift used with control keys", 0, 2)
  PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("You can use ", 0, 2)
  FG = 8: CALL ziPublish("SELECT CASE HResponse ", 0, 2): FG = 4
  CALL ziPublish("to separate the different inputs.", 0, 2)
  PRINT : PRINT : GOSUB NextLine
  FG = 8: CALL ziPublish("               ", 0, 2)
  CALL ziPublish("               <continued next page>", 0, 3): FG = 4

  CALL ziWander(0): CALL ziExhaust
 
  CALL ziSetMCursorVis(10)
  LINE (0, 17)-(Xmax, Ymax), 7, BF
  CALL ziSetMCursorVis(11)
  LOCATE 4, 10
  CALL zsAlignGCursor
 
  CALL ziPublish("  LResponse indicates the event:", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("     =  0 [ziDbl]       -DoubleClick (mouse)", 0, 2)
  GOSUB NextLine
  CALL ziPublish("     =  1 [ziL]         -Left arrow ", 0, 2)
  CALL ziPublish("or ", 0, 3)
  CALL ziPublish("Left Click", 0, 2)
  GOSUB NextLine
  CALL ziPublish("     =  2 [ziR]         -Right arrow ", 0, 2)
  CALL ziPublish("or ", 0, 3)
  CALL ziPublish("Right Click", 0, 2)
  GOSUB NextLine
  CALL ziPublish("     =  3 [ziUp]        -Up arrow ", 0, 2)
  GOSUB NextLine
  CALL ziPublish("     =  3 [ziBoth]      -Both Click (mouse)", 0, 2)
  GOSUB NextLine
  CALL ziPublish("     =  4 [ziDn]        -Down arrow", 0, 2)
  GOSUB NextLine
  CALL ziPublish("     =  4 [ziLDrag]     -Left drag (mouse)", 0, 2)
  GOSUB NextLine
  CALL ziPublish("     =  5 [ziBS]        -Backspace key", 0, 2)
  GOSUB NextLine
  CALL ziPublish("     =  5 [ziRDrag]     -Right drag (mouse)", 0, 2)
  GOSUB NextLine
  CALL ziPublish("     =  6 [ziHome]      -Home key", 0, 2)
  GOSUB NextLine
  CALL ziPublish("     =  6 [ziBothDrag]  -Both drag (mouse)", 0, 2)
  GOSUB NextLine
  CALL ziPublish("     =  7 [ziEnd]       -End key", 0, 2)
  GOSUB NextLine
  CALL ziPublish("     =  8 [ziPgUp]      -Page Up key", 0, 2)
  GOSUB NextLine
  CALL ziPublish("     =  9 [ziPgDn]      -Page Dn key", 0, 2)
  GOSUB NextLine
  CALL ziPublish("     = 10 [ziTab]       -Tab key", 0, 2)
  GOSUB NextLine
  CALL ziPublish("     = 11 [ziEsc]       -Escape key", 0, 2)
  PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("Also FUNCTION keys return values (1 to 12) in ", 0, 2)
  CALL ziPublish("LResponse", 0, 3)
  CALL ziPublish(".", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("If both ", 0, 2)
  CALL ziPublish("HResponse ", 0, 3)
  CALL ziPublish("and ", 0, 2)
  CALL ziPublish("LResponse ", 0, 3)
  CALL ziPublish("are zero, this signifies a TIMEOUT.", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("If ", 0, 2)
  CALL ziPublish("HResponse ", 0, 3)
  CALL ziPublish("is zero and ", 0, 2)
  CALL ziPublish("LResponse ", 0, 3)
  CALL ziPublish("is not zero, the keystroke made", 0, 2)
  GOSUB NextLine
  CALL ziPublish("can be expressed as ", 0, 2)
  FG = 8: CALL ziPublish("MID$(Allowed$, LResponse, 1)", 0, 2): FG = 4
  PRINT : PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("Note: if you wish ziWander to detect DoubleClicks you", 0, 2)
  GOSUB NextLine
  CALL ziPublish("must set the shared variable ", 0, 2)
  FG = 8: CALL ziPublish("DClick ", 0, 2): FG = 4
  CALL ziPublish("to hold the value 1.", 0, 2)
  GOSUB NextLine
  CALL ziPublish("It should be noted this can slow down processing.", 0, 2)
  RETURN
zzsAlignGCursor:
  CALL ziPublish("zsAlignGCursor ", 0, 3)
  CALL ziPublish("aligns the graphics cursor with the top", 0, 2)
  GOSUB NextLine
  CALL ziPublish("left corner of the character at the text cursor. This is ", 0, 2)
  GOSUB NextLine
  CALL ziPublish("useful when you use ziPublish, which employs the ", 0, 2)
  GOSUB NextLine
  CALL ziPublish("graphics cursor - not the text cursor.", 0, 2)
  PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("     LOCATE 3,19", 0, 2)
  GOSUB NextLine
  CALL ziPublish("     CALL zsAlignGCursor", 0, 2)
  GOSUB NextLine
  CALL ziPublish("     CALL ziPublish(String$, 0, 1)", 0, 0)
  PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("Note that the coordinates of the graphics cursor will", 0, 2)
  GOSUB NextLine
  CALL ziPublish("be recorded in shared variables ", 0, 2)
  CALL ziPublish("GXloc ", 0, 3)
  CALL ziPublish("and ", 0, 2)
  CALL ziPublish("GYloc", 0, 3)
  CALL ziPublish(".", 0, 2)
  RETURN
zzsAlignTCursor:
  CALL ziPublish("zsAlignTCursor ", 0, 3)
  CALL ziPublish("aligns the text cursor with the current", 0, 2)
  GOSUB NextLine
  CALL ziPublish("location of the graphics corner, and realigns the", 0, 2)
  GOSUB NextLine
  CALL ziPublish("graphics cursor so that it is at the top left corner", 0, 2)
  GOSUB NextLine
  CALL ziPublish("of the text character position.  This is useful for", 0, 2)
  GOSUB NextLine
  CALL ziPublish("combining text with a graphic that already appears.", 0, 2)
  PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("     CALL zsLocateGCursor(100,35)", 0, 2)
  GOSUB NextLine
  CALL ziPublish("     CALL zsAlignTCursor", 0, 2)
  GOSUB NextLine
  CALL ziPublish("     PRINT Sring$", 0, 2)
  RETURN
zzsLocateGCursor:
  CALL ziPublish("zsLocateGCursor ", 0, 3)
  CALL ziPublish("is a means of providing new coordinates for", 0, 2)
  GOSUB NextLine
  CALL ziPublish("the graphics cursor, performing a similar function to", 0, 2)
  GOSUB NextLine
  CALL ziPublish("that of the LOCATE command (which provides new text", 0, 2)
  GOSUB NextLine
  CALL ziPublish("coordinates.", 0, 2)
  PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("     CALL zsLocateGCursor(X, Y)", 0, 2)
  PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("..will do the job, also recording the coordinates in the", 0, 2)
  GOSUB NextLine
  CALL ziPublish("shared variables ", 0, 2)
  CALL ziPublish("GXloc ", 0, 3)
  CALL ziPublish("and ", 0, 2)
  CALL ziPublish("GYloc", 0, 3)
  CALL ziPublish(".", 0, 2)
  RETURN
zzsPastel:
  aa = (Xmax + 1) \ 26
  bb = aa / XYratio!
  FOR i = 1 TO 16
   FOR j = i TO 16
    k = 200 + j * aa: l = 10 + i * bb
    CALL ziSetMCursorVis(10)
    LINE (k, l)-(k + aa, l + bb), 0, B
    CALL ziSetMCursorVis(11)
    CALL zsPastel(k + 1, l + 1, aa - 1, bb - 1, i - 1, j - 1)
   NEXT
  NEXT
  FOR i = 1 TO 16
    CALL zsLocateGCursor(200 + i * aa, 13)
    CALL ziPublish(STR$(i - 1), 0, 0)
    CALL zsLocateGCursor(201 + 17 * aa, 15 + i * bb)
    CALL ziPublish(STR$(i - 1), 0, 0)
  NEXT
  LOCATE 10, 10
  CALL zsAlignGCursor
  CALL ziPublish("ziPastel ", 0, 3)
  CALL ziPublish("creates a", 0, 2)
  GOSUB NextLine
  CALL ziPublish("rectangle, filling it", 0, 2)
  GOSUB NextLine
  CALL ziPublish("with a mixture of any two", 0, 2)
  GOSUB NextLine
  CALL ziPublish("specified colours.", 0, 2)
  LOCATE CSRLIN + 11, 2: CALL zsAlignGCursor
  FG = 4
  CALL ziPublish("CALL ziPastel(X, Y, width, depth, colour1, colour2)", 0, 2)
  FG = 0
  PRINT : PRINT : CALL zsAlignGCursor
  CALL ziPublish(" ..will do the job; the chart on the right", 0, 2)
  PRINT : CALL zsAlignGCursor
  CALL ziPublish(" demonstrates the effects of mixing any two", 0, 2)
  PRINT : CALL zsAlignGCursor
  CALL ziPublish(" colours.", 0, 2)
  PRINT : PRINT : CALL zsAlignGCursor
  CALL ziPublish(" Note also that if ", 0, 2)
  CALL ziPublish("depth ", 0, 3)
  CALL ziPublish("is recorded as zero", 0, 2)
  PRINT : CALL zsAlignGCursor
  CALL ziPublish(" that an appropriate value will be substituted", 0, 2)
  PRINT : CALL zsAlignGCursor
  CALL ziPublish(" to generate a square (in appearance) area.", 0, 2)
  RETURN
zzsSetScrnMode:
  CALL ziPublish("zsSetScrnMode ", 0, 3)
  CALL ziPublish("enables you to set the SCREEN mode to 9 or 12 -", 0, 2)
  GOSUB NextLine
  CALL ziPublish("the two most generally useful graphics environments.", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("At the same time it will provide appropriate values", 0, 2)
  GOSUB NextLine
  CALL ziPublish("for the following shared variables:", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("ScrnMode - ", 0, 3)
  CALL ziPublish("integer 9 or 12", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("Xmax     - ", 0, 3)
  CALL ziPublish("integer maximum X coordinate on screen (e.g. 639)", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("Ymax     - ", 0, 3)
  CALL ziPublish("integer maximum Y coordinate on screen (e.g. 349)", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("XYratio! - ", 0, 3)
  CALL ziPublish("aspect ratio for X and Y pixels", 0, 2)
  GOSUB NextLine
  CALL ziPublish("           Note:  ", 0, 2)
  FG = 4: CALL ziPublish("Ylength = Xlength / XYratio!", 0, 2)
  GOSUB NextLine
  CALL ziPublish("                  Xlength = Ylength * XYratio!", 0, 2)
  FG = 0
  GOSUB NextLine
  CALL ziPublish("           These calculations will provide values", 0, 2)
  GOSUB NextLine
  CALL ziPublish("           that look the same length on the screen.", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("Rows     - ", 0, 3)
  CALL ziPublish("integer maximum text rows on screen (e.g. 43)", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("Cols     - ", 0, 3)
  CALL ziPublish("integer maximum text columns on screen (e.g. 80)", 0, 2)
  PRINT : PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("     CALL zsSetScrnMode(", 0, 2)
  FG = 4: CALL ziPublish("mode", 0, 2)
  FG = 0: CALL ziPublish(", ", 0, 2)
  FG = 4: CALL ziPublish("rows_switch", 0, 2)
  FG = 0: CALL ziPublish(", ", 0, 2)
  FG = 4: CALL ziPublish("cols_switch", 0, 2)
  FG = 0: CALL ziPublish(") ", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("..where", 0, 2)
  GOSUB NextLine
  FG = 4: CALL ziPublish("      mode ", 0, 2)
  FG = 0: CALL ziPublish("is a constant or variable 9 or 12", 0, 2)
  GOSUB NextLine
  FG = 4: CALL ziPublish("      rows_switch ", 0, 2)
  FG = 0: CALL ziPublish("is a constant or variable 0 or 1", 0, 2)
  GOSUB NextLine
  CALL ziPublish("        indicating if maximum rows (43 or 60) should", 0, 2)
  GOSUB NextLine
  CALL ziPublish("        be used.", 0, 2)
  GOSUB NextLine
  FG = 4: CALL ziPublish("      cols_switch ", 0, 2)
  FG = 0: CALL ziPublish("is a constant or variable 0 or 1", 0, 2)
  GOSUB NextLine
  CALL ziPublish("        indicating if maximum columns (80) should", 0, 2)
  GOSUB NextLine
  CALL ziPublish("        be used.", 0, 2)
  PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("Note that shared variables BG and FG should be set for", 0, 2)
  GOSUB NextLine
  CALL ziPublish("appropriate background and foreground colours before", 0, 2)
  GOSUB NextLine
  CALL ziPublish("calling this subroutine.", 0, 2)
  RETURN
zzsSubstitute:
  CALL ziPublish("zsSubstitute ", 0, 3)
  CALL ziPublish("provides a way of changing every pixel within a", 0, 2)
  GOSUB NextLine
  CALL ziPublish("rectangular region from one colour to another.", 0, 2)
  a = (Xmax + 1) \ 5: aa = a + a + a
  LINE (a, 70)-(a + a - 1, 69 + a / XYratio!), 0, B
  LINE (aa, 70)-(aa + a - 1, 69 + a / XYratio!), 0, B
  PAINT (a + 2, 72), 10, 0
  PAINT (aa + 2, 72), 10, 0
  CIRCLE (a + a / 4, 70 + a / 4 / XYratio!), a / 5, 0
  CIRCLE (a + a * .75, 70 + a * .75 / XYratio!), a / 5, 0
  PAINT (a + a / 4 + 2, 70 + a / 4 + 2), 14, 0
  PAINT (a + a * .75 + 2, 70 + a * .75 / XYratio! + 2), 14, 0
  CIRCLE (aa + a / 4, 70 + a / 4 / XYratio!), a / 5, 0
  CIRCLE (aa + a * .75, 70 + a * .75 / XYratio!), a / 5, 0
  PAINT (aa + a / 4 + 2, 70 + a / 4 + 2), 14, 0
  PAINT (aa + a * .75 + 2, 70 + a * .75 / XYratio! + 2), 14, 0
  CALL zsLocateGCursor(a + a / 2 - 24, 78 + a / XYratio!)
  CALL zsAlignTCursor
  CALL ziPublish("BEFORE", 0, 0)
  CALL zsLocateGCursor(aa + a / 2 - 24, 78 + a / XYratio!)
  CALL zsAlignTCursor
  CALL ziPublish(" AFTER", 0, 0)
  PRINT : PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("Try this little program: (click or press space)", 0, 2)
  PRINT : PRINT : GOSUB NextLine
  remline = CSRLIN
  FG = 8
  CALL ziPublish("  CALL zsSubstitute(X, Y, width, depth, 14, 12)", 0, 2)
  GOSUB NextLine
  CALL ziPublish("  CALL zsSubstitute(X, Y, width, depth, 10, 14)", 0, 2)
  GOSUB NextLine
  CALL ziPublish("  CALL zsSubstitute(X, Y, width, depth, 12, 10)", 0, 2)
  FG = 0
  PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("Note: 10 = bright green; 12 = bright red; 14 = yellow", 0, 3)

  FOR i = 1 TO 4
    DO
      CALL ziWander(0)
      CALL ziExhaust
      SELECT CASE HResponse
      CASE 0: EXIT DO
      CASE ziMouse: IF LResponse = 1 THEN EXIT DO
      END SELECT
    LOOP
    SELECT CASE i
    CASE 1
      NewString$ = "14, 12)"
      clr1 = 14: clr2 = 12
    CASE 2
      NewString$ = "10, 14)"
      clr1 = 10: clr2 = 14
    CASE 3
      NewString$ = "12, 10)"
      clr1 = 12: clr2 = 10
    END SELECT
    IF i > 1 THEN
      LOCATE remline + i - 3, 1
      CALL zsAlignGCursor
      GOSUB NextLine
      FG = 8
      CALL ziPublish("  CALL zsSubstitute(X, Y, width, depth, ", 0, 2)
      CALL ziPublish(OldString$, 0, 2)
    END IF
    OldString$ = NewString$
    IF i < 4 THEN
      LOCATE remline + i - 2, 1
      CALL zsAlignGCursor
      GOSUB NextLine
      FG = 4
      CALL ziPublish("  CALL zsSubstitute(X, Y, width, depth, ", 0, 2)
      CALL ziPublish(NewString$, 0, 2)
      CALL zsSubstitute(aa, 70, a - 1, a / XYratio! - 1, clr1, clr2)
    END IF
  NEXT
  RETURN
zzzBasicInt:
  CALL ziPublish("zzBasicInt ", 0, 3)
  CALL ziPublish("enables the QBasic programmer to access DOS and BIOS", 0, 2)
  GOSUB NextLine
  CALL ziPublish("interrupts, passing inward parameter values in registers", 0, 2)
  GOSUB NextLine
  CALL ziPublish("and receiving outward parameter values in registers, and", 0, 2)
  GOSUB NextLine
  CALL ziPublish("also receiving flag status information.", 0, 2)
  PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("   CALL zzBasicInt(", 0, 2)
  FG = 4: CALL ziPublish("interrupt", 0, 2): FG = 1
  CALL ziPublish(")", 0, 2)
  PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("..where", 0, 2)
  GOSUB NextLine
  FG = 4: CALL ziPublish("     interrupt ", 0, 2): FG = 1
  CALL ziPublish("is an integer variable or constant.", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("Parameters are passed back and forth in the shared", 0, 2)
  GOSUB NextLine
  CALL ziPublish("integers in the REGS structure:", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("    REGS.AX", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("    REGS.BX", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("    REGS.CX", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("    REGS.DX", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("    REGS.DS", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("    REGS.SI", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("    REGS.ES", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("    REGS.DI", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("    REGS.FL  (flags: read only)", 0, 2)
  PRINT : PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("Note: zzBasicInt loads and uses a file called BASICINT.OVL", 0, 2)
  RETURN
zzzInPath:
  CALL ziPublish("zzInPath ", 0, 3)
  CALL ziPublish("tests whether a particular file can be found within", 0, 2)
  GOSUB NextLine
  CALL ziPublish("the current directory or the defined PATH.", 0, 2)
  PRINT : GOSUB NextLine
  CALL ziPublish("The name of the file is passed to the subroutine in a", 0, 2)
  GOSUB NextLine
  CALL ziPublish("string variable, and the FULL path to the file will be", 0, 2)
  GOSUB NextLine
  CALL ziPublish("passed back in the same variable. If the file is not found", 0, 2)
  GOSUB NextLine
  CALL ziPublish("the variable will be set to nul.", 0, 2)
  PRINT : PRINT : PRINT : GOSUB NextLine
  CALL ziPublish("This subroutine can be used effectively in conjunction", 0, 2)
  GOSUB NextLine
  CALL ziPublish("with the BLOAD command so that overlays and graphics need", 0, 2)
  GOSUB NextLine
  CALL ziPublish("not be kept in the same development directory.", 0, 2)
  RETURN

NextLine:
  PRINT
  LOCATE , 10
  CALL zsAlignGCursor
  RETURN

'++++++++++++++++++++++++
SUB ziDragging

  IF Mouse AND MCursorVis THEN
    SELECT CASE Response
    CASE 2052 TO 2054
      REGS.AX = 3
      CALL zzBasicInt(&H33)
      IF REGS.BX = Response - 2051 THEN
        EXIT SUB
      END IF
    END SELECT
  END IF
  CALL ziExhaust

END SUB

'++++++++++++++++++++++++
SUB ziDrawBank (FromButton, ToButton)

  CALL ziSetMCursorVis(10)

  FOR i = FromButton TO ToButton

    IF Bank(i).Active THEN

      IF Bank(i).State THEN
        colour1 = 8
      ELSE
        colour1 = 15
      END IF
      colour2 = colour1 XOR 7

      XCoord = Bank(i).Xloc
      YCoord = Bank(i).Yloc
      XWidth = Bank(i).Wide
      YDepth = Bank(i).Deep
      X2Coord = XCoord + XWidth

      IF YDepth THEN
        IF YDepth = 1 THEN
          Y2Coord = YCoord + XWidth / XYratio!
        ELSE
          Y2Coord = YCoord + YDepth
        END IF
        LINE (XCoord, YCoord)-(X2Coord - 1, YCoord), colour1
        LINE (XCoord, YCoord)-(XCoord, Y2Coord - 1), colour1
        LINE (XCoord + 1, Y2Coord)-(X2Coord, Y2Coord), colour2
        LINE (X2Coord, YCoord)-(X2Coord, Y2Coord), colour2
      ELSE
        a = XWidth \ 2
        B = a / XYratio!
        c = XCoord + a
        d = YCoord + B

        LINE (XCoord, YCoord)-(c + a, d + B), 7, BF

        CIRCLE (c, d), a, 8
        CIRCLE (c, d), a - 1, 8
        PAINT (c, d), 7, 7
        IF Bank(i).State THEN
          CIRCLE (c, d), XWidth \ 3, 8
          PAINT (c, d), 8, 8
        END IF
      END IF
    END IF

  NEXT

  CALL ziSetMCursorVis(11)

END SUB

'++++++++++++++++++++++++
SUB ziExhaust

  DO
    X$ = INKEY$
  LOOP WHILE LEN(X$)

  IF Mouse AND MCursorVis THEN
    DO
      REGS.AX = 3
      CALL zzBasicInt(&H33)
    LOOP WHILE (REGS.BX AND 3)
  END IF
  Response = 0
END SUB

'++++++++++++++++++++++++
SUB ziLoadFont (Font$)

  DEF SEG = VARSEG(Font(0, 0))

  Module$ = Font$ + ".OVL"
  CALL zzInPath(Module$)
  IF Module$ = "" THEN
    Module$ = Font$ + ".OVL"
    ERROR 255
  ELSE
    BLOAD Module$, VARPTR(Font(0, 0))
  END IF

  DEF SEG

END SUB

'++++++++++++++++++++++++
SUB ziLocateMCursor (XCoord, YCoord)

  IF Mouse THEN
    MXloc = XCoord
    MYloc = YCoord
    REGS.AX = 4
    REGS.CX = XCoord
    REGS.DX = YCoord
    CALL zzBasicInt(&H33)
    CALL ziSetMCursorVis(1)
  END IF

END SUB

'++++++++++++++++++++++++
SUB ziMouseOnButton (FromButton, ToButton)

  FoundButton = 0
  FOR i = FromButton TO ToButton
    IF Bank(i).Active THEN
      IF Bank(i).Deep < 2 THEN
        j = Bank(i).Wide / XYratio!
      ELSE
        j = Bank(i).Deep
      END IF
      IF MXloc > Bank(i).Xloc THEN
        IF MXloc < Bank(i).Xloc + Bank(i).Wide THEN
          IF MYloc > Bank(i).Yloc THEN
            IF MYloc < Bank(i).Yloc + j THEN
              FoundButton = i
              EXIT SUB
            END IF
          END IF
        END IF
      END IF
    ELSE
      EXIT SUB
    END IF
  NEXT

END SUB

'++++++++++++++++++++++++
SUB ziPublish (PrintString$, Size, Italic)

  CALL ziSetMCursorVis(10)

  xx = POINT(0)
  yy = POINT(1)
  IF Size THEN
    Scale = Size
  ELSE
    Scale = 1
  END IF

  LenString = LEN(PrintString$)

  ExpScale = 8 * Scale
  limxx = xx + ExpScale * LenString - 1
  limyy = yy + ExpScale - 1

  IF Italic AND 1 THEN
    limxx = limxx + 4 * Scale
  END IF


  IF Italic AND 2 THEN
  ELSE
    LINE (xx, yy)-(limxx, limyy), BG, BF
  END IF


  FOR a = 0 TO LenString - 1
    X = ASC(MID$(PrintString$, a + 1, 1))
    B = xx + ExpScale * a
    FOR Y = 0 TO 7
      c = Font(X, Y)
      d = Y * Scale
      e = yy + d
      IF Italic AND 1 THEN
        f = B + 4 * Scale - (d + Scale - 1) \ 2 - 1
      ELSE
        f = B
      END IF
      g = 128
      DO
        IF c AND g THEN
          FOR h = 0 TO Scale - 1
            FOR i = 0 TO Scale - 1
              PSET (f + h, e + i), FG
            NEXT
          NEXT
        END IF
        f = f + Scale
        g = g \ 2
      LOOP UNTIL g = 0
    NEXT
  NEXT
  CALL zsLocateGCursor(limxx + 1, yy)

  CALL ziSetMCursorVis(11)

END SUB

'++++++++++++++++++++++++
SUB ziRadio (Button, FromButton, ToButton)

  IF Button >= FromButton THEN
    IF Button <= ToButton THEN
      FOR a = FromButton TO ToButton
        Bank(a).State = 0
      NEXT
    END IF
  END IF

  Bank(Button).State = 1
  CALL ziDrawBank(FromButton, ToButton)

END SUB

'++++++++++++++++++++++++
SUB ziReadField (Min, Max, Permitted$)

  CALL ziSetMCursorVis(10)

  atRow = CSRLIN
  atCol = POS(X)
  Field$ = ""
  PRINT CHR$(219); SPACE$(Max);
  Rules$ = UCASE$(Permitted$)

  Brake = 1
  WHILE Brake
    X$ = ""
    WHILE LEN(X$) = 0
      X$ = INKEY$
    WEND
    IF INSTR(Rules$, "C") THEN X$ = UCASE$(X$)
    oldLen = LEN(Field$)
    Good = 0
    IF INSTR(Rules$, ".") THEN
      IF X$ = "." THEN
        IF INSTR(Field$, ".") = 0 THEN
          Good = 1
        END IF
      END IF
    END IF
    IF INSTR(Rules$, "N") THEN
      IF INSTR("0123456789", X$) THEN
        Good = 1
      END IF
    END IF
    IF INSTR(Rules$, "S") THEN
      IF X$ = " " THEN
        Good = 1
      END IF
    END IF
    IF INSTR(Rules$, "X") THEN
      IF INSTR("ABCDEFGHIJKLMNOPQRSTUVWXYZ", UCASE$(X$)) THEN
        Good = 1
      END IF
    END IF
    IF INSTR(Rules$, "Y") THEN
      IF INSTR("YyNy", X$) THEN
        Good = 1
      END IF
    END IF
    IF Good THEN
      Field$ = Field$ + X$
      IF INSTR(Field$, ".") THEN
        NewMax = Max + 1
      ELSE
        NewMax = Max
      END IF
      Field$ = MID$(Field$, 1, NewMax)
    END IF

    ' handle Bkspace
    IF ASC(X$) = 8 AND LEN(Field$) THEN
      Field$ = MID$(Field$, 1, LEN(Field$) - 1)
    END IF

    Signif$ = Field$ + "X"
    WHILE INSTR(" 0", MID$(Signif$, 1, 1))
      Signif$ = MID$(Signif$, 2)
    WEND
    IF INSTR(Signif$, ".") THEN
      SignifLen = LEN(Signif$) - 2
    ELSE
      SignifLen = LEN(Signif$) - 1
    END IF

    ' handle Enter
    IF ASC(X$) = 13 AND SignifLen >= Min THEN
      oldLen = LEN(Field$) + 1
      Brake = 0
    END IF

    ' handle Esc
    IF ASC(X$) = 27 THEN
      LOCATE atRow, atCol
      PRINT CHR$(219); SPACE$(Max);
      Field$ = ""
      IF INSTR(Rules$, "E") THEN
        RETURN
      END IF
    END IF

    ' reprint if change, or beep if no change
    IF oldLen = LEN(Field$) THEN
      BEEP
    ELSE
      LOCATE atRow, atCol
      IF INSTR(Rules$, "P") THEN
        PRINT STRING$(LEN(Field$), 254); CHR$(219); " ";
      ELSE
        PRINT Field$; CHR$(219); " ";
      END IF
    END IF

    ' check for auto-Enter
    IF INSTR(Rules$, "A") THEN
      IF SignifLen = Max THEN
        Brake = 0
      END IF
    END IF
  WEND

  ' justify if required
  IF INSTR(Rules$, "J") THEN
    WHILE MID$(Field$, 1, 1) = "0"
      Field$ = MID$(Field$, 2)
    WEND
    Field$ = RIGHT$(SPACE$(NewMax) + Field$, NewMax)
  END IF

  ' reprint, deleting the cursor
  LOCATE atRow, atCol
  IF INSTR(Rules$, "P") THEN
    PRINT STRING$(LEN(Field$), 254); " ";
  ELSE
    PRINT Field$; " ";
  END IF

  CALL ziSetMCursorVis(11)

END SUB

'++++++++++++++++++++++++
SUB ziSetMCursorVis (Status) STATIC

  IF Mouse THEN
    SELECT CASE Status
    CASE 0
      IF MCursorVis THEN
       REGS.AX = 2
       CALL zzBasicInt(&H33)
      END IF
    CASE 1
      REGS.AX = 1
      CALL zzBasicInt(&H33)
    CASE 10
      REGS.AX = &H2A
      CALL zzBasicInt(&H33)
      IF REGS.AX = 0 THEN
        TempFlag = 1
        REGS.AX = 2
        CALL zzBasicInt(&H33)
      ELSE
        TempFlag = 0
      END IF
    CASE 11
      IF TempFlag THEN
        REGS.AX = 1
        CALL zzBasicInt(&H33)
      END IF
    END SELECT
    REGS.AX = &H2A
    CALL zzBasicInt(&H33)
    IF REGS.AX = 0 THEN
      MCursorVis = 1
    ELSE
      MCursorVis = 0
    END IF
  END IF
END SUB

'++++++++++++++++++++++++
SUB ziWander (Timeout!)

  IF Timeout! = 0 THEN
    WatchFor! = TIMER + 3600
  ELSE
    WatchFor! = TIMER + Timeout!
  END IF

  Response = 0

  DO
    X$ = INKEY$
    IF LEN(X$) THEN
      SELECT CASE LEN(X$)
      CASE 1
        a = INSTR(Allowed$, X$)
        IF a THEN
          Response = a
          EXIT DO
        END IF
        SELECT CASE ASC(X$)
        CASE 8: Response = 261
        CASE 9: Response = 266
        CASE 10: Response = 512
        CASE 13: Response = 256
        CASE 27: Response = 267
        CASE 127: Response = 517
        END SELECT
        IF Response THEN
          EXIT DO
        END IF
      CASE 2
        Rightmost = ASC(RIGHT$(X$, 1))
        SELECT CASE Rightmost
        CASE 15: Response = 1019
        CASE 59 TO 68
          Response = 4038
        CASE 72: Response = 187
        CASE 71 TO 73
          Response = 191
        CASE 75: Response = 182
        CASE 77: Response = 181
        CASE 80: Response = 180
        CASE 79 TO 81
          Response = 184
        CASE 84 TO 93
          Response = 16301
        CASE 94 TO 103
          Response = 8099
        CASE 115 TO 116
          Response = 398
        CASE 117: Response = 402
        CASE 118: Response = 403
        CASE 119: Response = 399
        CASE 127: Response = 390
        CASE 132: Response = 388
        CASE 133 TO 134
          Response = 3974
        CASE 135 TO 136
          Response = 16260
        CASE 137 TO 138
          Response = 8066
        END SELECT
        IF Response THEN
          Response = Response + Rightmost
          EXIT DO
        END IF
      END SELECT
    END IF

    IF Mouse AND MCursorVis THEN
      REGS.AX = 3
      CALL zzBasicInt(&H33)
      SELECT CASE REGS.BX
      CASE 1 TO 3
        Response = 2048 + REGS.BX
        nowtime! = TIMER
        DO
          REGS.AX = 3
          CALL zzBasicInt(&H33)
          IF REGS.BX = 0 THEN EXIT DO
        LOOP UNTIL TIMER - nowtime! > .3
        IF REGS.BX = Response - 2048 THEN
          Response = Response + 3
        ELSE
          IF REGS.BX = 0 AND Response = 2049 AND DClick THEN
            nowtime! = TIMER
            DO
              REGS.AX = 3
              CALL zzBasicInt(&H33)
              IF REGS.BX = 1 THEN EXIT DO
            LOOP UNTIL TIMER - nowtime! > .3
            IF REGS.BX = 1 THEN
              Response = 2048
              CALL ziExhaust
            END IF
          END IF
          IF REGS.BX = 3 THEN
            Response = 2051
          END IF
        END IF
      END SELECT
      IF Response THEN
        MXloc = REGS.CX
        MYloc = REGS.DX
        EXIT DO
      END IF
    END IF

  LOOP UNTIL WatchFor! < TIMER
  HResponse = Response \ 256
  LResponse = Response MOD 256

END SUB

'++++++++++++++++++++++++
SUB zsAlignGCursor

  Row = CSRLIN
  Col = POS(0)
  GXloc = (Col - 1) * (Xmax + 1) \ Cols
  GYloc = (Row - 1) * ((Ymax \ Rows) * Rows + 1) \ Rows
  CALL zsLocateGCursor(GXloc, GYloc)

END SUB

'++++++++++++++++++++++++
SUB zsAlignTCursor

  GXloc = POINT(0)
  GYloc = POINT(1)
  a = (Xmax + 1) / Cols
  B = (Ymax + 1) / Rows
  Col = (GXloc + a - 1) \ a + 1
  Row = (GYloc + B - 1) \ B + 1
  LOCATE Row, Col
  CALL zsAlignGCursor

END SUB

'++++++++++++++++++++++++
SUB zsLocateGCursor (XCoord, YCoord)

  GXloc = XCoord
  GYloc = YCoord
  PSET (GXloc, GYloc), POINT(GXloc, GYloc)

END SUB

'++++++++++++++++++++++++
SUB zsPastel (XCoord, YCoord, Wide, Deep, colour1, colour2)

  CALL ziSetMCursorVis(10)

  IF Deep < 2 THEN
    a = Wide / XYratio!
  ELSE
    a = Deep
  END IF

  LINE (XCoord, YCoord)-(XCoord + Wide - 1, YCoord + a - 1), colour1, BF
  FOR B = XCoord TO XCoord + Wide - 1 STEP 2
    LINE (B, YCoord)-(B, YCoord + a - 1), colour2, , &H5555
  NEXT
  FOR B = XCoord + 1 TO XCoord + Wide - 1 STEP 2
    LINE (B, YCoord)-(B, YCoord + a - 1), colour2, , &HAAAA
  NEXT

  CALL ziSetMCursorVis(11)

END SUB

'++++++++++++++++++++++++
SUB zsSetScrnMode (Mode, HiRows, HiCols)

  CALL ziSetMCursorVis(10)

  ScrnMode = Mode
  IF Mode = 9 THEN
    SCREEN 9
    IF HiRows THEN
      Rows = 43
    ELSE
      Rows = 25
    END IF
    Xmax = 639
    Ymax = 349
  END IF
  IF Mode = 12 THEN
    SCREEN 12
    IF HiRows THEN
      Rows = 60
    ELSE
      Rows = 30
    END IF
    Xmax = 639
    Ymax = 479
  END IF

  IF HiCols THEN
    Cols = 80
  ELSE
    Cols = 40
  END IF
  WIDTH Cols, Rows
  CLS
  IF Mode = 9 THEN
    COLOR FG, BG
  ELSE
    COLOR FG
  END IF
  LINE (0, 0)-(Xmax, Ymax), BG, BF
  LOCATE 1, 1, 0
  PSET (0, 0), BG
  XYratio! = .75 * (Xmax + 1) / (Ymax + 1)

  CALL ziSetMCursorVis(11)

END SUB

'++++++++++++++++++++++++
SUB zsSubstitute (XCoord, YCoord, Wide, Deep, colour1, colour2)

  CALL ziSetMCursorVis(10)

  IF Deep < 2 THEN
    a = Wide / XYratio!
  ELSE
    a = Deep
  END IF
  FOR B = XCoord TO XCoord + Wide - 1
    FOR c = YCoord TO YCoord + a - 1
      IF POINT(B, c) = colour1 THEN
        PSET (B, c), colour2
      END IF
    NEXT
  NEXT

  CALL ziSetMCursorVis(11)

END SUB

'++++++++++++++++++++++++
SUB zzBasicInt (IntType) STATIC

  DIM ASM(54)
  DEF SEG = VARSEG(ASM(0))

  IF ASM(1) = 0 THEN
    Module$ = "BASICINT.OVL"
    CALL zzInPath(Module$)
    IF Module$ = "" THEN
      Module$ = "BASICINT.OVL"
      ERROR 255
    ELSE
      BLOAD Module$, VARPTR(ASM(0))
    END IF
  END IF

  CALL ABSOLUTE(REGS, IntType, VARPTR(ASM(0)))

  DEF SEG

END SUB

'++++++++++++++++++++++++
SUB zzInPath (Field$)

  X$ = ".;" + ENVIRON$("PATH")
  IF RIGHT$(X$, 1) <> ";" THEN X$ = X$ + ";"
  i = 1
  DO
    j = INSTR(i, X$, ";")
    IF j THEN
      Y$ = UCASE$(MID$(X$, i, j - i))
      i = j + 1
      IF RIGHT$(Y$, 1) <> "\" THEN Y$ = Y$ + "\"
      f$ = Y$ + Field$
      Bad = 0
      OPEN "I", 1, f$
      IF Bad = 0 THEN
        CLOSE 1
        EXIT DO
      END IF
      f$ = ""
    END IF
  LOOP WHILE j
  Bad = 0
  Field$ = f$

END SUB

